searchNodes=[{"doc":"Elixir client for Confluent Schema Registry API .","ref":"ConfluentSchemaRegistry.html","title":"ConfluentSchemaRegistry","type":"module"},{"doc":"Create client to talk to Schema Registry. Options are: base_url: URL of schema registry (optional, default &quot; http://localhost:8081&quot; ) username: username for BasicAuth (optional) password: password for BasicAuth (optional) adapter: Tesla adapter config middleware: List of additional middleware module config (optional) Examples iex&gt; client = ConfluentSchemaRegistry . client ( ) % Tesla.Client { adapter : nil , fun : nil , post : [ ] , pre : [ { Tesla.Middleware.BaseUrl , :call , [ &quot;http://localhost:8081&quot; ] } , { Tesla.Middleware.Headers , :call , [ [ { &quot;content-type&quot; , &quot;application/vnd.schemaregistry.v1+json&quot; } ] ] } , { Tesla.Middleware.JSON , :call , [ [ decode_content_types : [ &quot;application/vnd.schemaregistry.v1+json&quot; ] ] ] } ] }","ref":"ConfluentSchemaRegistry.html#client/1","title":"ConfluentSchemaRegistry.client/1","type":"function"},{"doc":"Deletes the specified subject and its associated compatibility level if registered. It is recommended to use this API only when a topic needs to be recycled or in development environment. https://docs.confluent.io/current/schema-registry/develop/api.html#delete--subjects-(string-%20subject) Returns list of integer ids. Examples iex&gt; ConfluentSchemaRegistry . delete_subject ( client , &quot;test&quot; ) { :ok , [ 1 ] }","ref":"ConfluentSchemaRegistry.html#delete_subject/2","title":"ConfluentSchemaRegistry.delete_subject/2","type":"function"},{"doc":"Deletes a specific version of the schema registered under this subject. This only deletes the version and the schema ID remains intact making it still possible to decode data using the schema ID. https://docs.confluent.io/current/schema-registry/develop/api.html#delete--subjects-(string-%20subject)-versions-(versionId-%20version) { :ok , 1 } = ConfluentSchemaRegistry . delete_version ( client , &quot;test&quot; ) # latest { :ok , 1 } = ConfluentSchemaRegistry . delete_version ( client , &quot;test&quot; , 1 ) Returns integer id of deleted version.","ref":"ConfluentSchemaRegistry.html#delete_version/3","title":"ConfluentSchemaRegistry.delete_version/3","type":"function"},{"doc":"Get global compatibility level. Level is a string which will be one of BACKWARD, BACKWARD_TRANSITIVE, FORWARD, FORWARD_TRANSITIVE, FULL, FULL_TRANSITIVE, NONE https://docs.confluent.io/current/schema-registry/develop/api.html#put--config Returns string. Examples iex&gt; ConfluentSchemaRegistry . get_compatibility ( client ) { :ok , &quot;BACKWARD&quot; }","ref":"ConfluentSchemaRegistry.html#get_compatibility/1","title":"ConfluentSchemaRegistry.get_compatibility/1","type":"function"},{"doc":"Get compatibility level for a subject. Level is a string which will be one of BACKWARD, BACKWARD_TRANSITIVE, FORWARD, FORWARD_TRANSITIVE, FULL, FULL_TRANSITIVE, NONE https://docs.confluent.io/current/schema-registry/develop/api.html#put--config Returns string. Examples iex&gt; ConfluentSchemaRegistry . get_compatibility ( client , &quot;test&quot; ) { :ok , &quot;FULL&quot; }","ref":"ConfluentSchemaRegistry.html#get_compatibility/2","title":"ConfluentSchemaRegistry.get_compatibility/2","type":"function"},{"doc":"Get the schema string identified by the input ID. https://docs.confluent.io/current/schema-registry/develop/api.html#get--schemas-ids-int-%20id Returns binary schema. Examples iex&gt; ConfluentSchemaRegistry . get_schema ( client , 21 ) { :ok , &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; }","ref":"ConfluentSchemaRegistry.html#get_schema/2","title":"ConfluentSchemaRegistry.get_schema/2","type":"function"},{"doc":"Get a specific version of the schema registered under this subject https://docs.confluent.io/current/schema-registry/develop/api.html#delete--subjects-(string-%20subject) Returns a map with the following keys: subject (string) -- Name of the subject that this schema is registered under id (int) -- Globally unique identifier of the schema version (int) -- Version of the returned schema schema (string) -- The Avro schema string case ConfluentSchemaRegistry . get_schema ( client , &quot;test&quot; , &quot;latest&quot; ) do { :ok , reg } -&gt; # Already registered schema = reg [ &quot;schema&quot; ] schema_id = reg [ &quot;id&quot; ] { :error , 404 , %{ &quot;error_code&quot; =&gt; 40401 } } -&gt; # Subject not found { :error , 404 , %{ &quot;error_code&quot; =&gt; 40402 } } -&gt; # Version not found { :error , 422 , reason } -&gt; # Unprocessable Entity, Invalid Avro version { :error , code , reason } -&gt; # Other error end Examples iex&gt; ConfluentSchemaRegistry . get_schema ( client , &quot;test&quot; ) { :ok , %{ &quot;id&quot; =&gt; 21 , &quot;schema&quot; =&gt; &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; , &quot;subject&quot; =&gt; &quot;test&quot; , &quot;version&quot; =&gt; 13 } } iex&gt; ConfluentSchemaRegistry . get_schema ( client , &quot;test&quot; , 13 ) { :ok , %{ &quot;id&quot; =&gt; 21 , &quot;schema&quot; =&gt; &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; , &quot;subject&quot; =&gt; &quot;test&quot; , &quot;version&quot; =&gt; 13 } }","ref":"ConfluentSchemaRegistry.html#get_schema/3","title":"ConfluentSchemaRegistry.get_schema/3","type":"function"},{"doc":"Get a list of registered subjects. https://docs.confluent.io/current/schema-registry/develop/api.html#get--subjects Returns list of subject name strings. Examples iex&gt; ConfluentSchemaRegistry . get_subjects ( client ) { :ok , [ &quot;test&quot; ] }","ref":"ConfluentSchemaRegistry.html#get_subjects/1","title":"ConfluentSchemaRegistry.get_subjects/1","type":"function"},{"doc":"Get a list of versions registered under the specified subject. https://docs.confluent.io/current/schema-registry/develop/api.html#get--subjects-(string-%20subject)-versions { :ok , [ 1 , 2 , 3 , 4 ] } = ConfluentSchemaRegistry . get_versions ( client , &quot;test&quot; ) Returns list of integer ids.","ref":"ConfluentSchemaRegistry.html#get_versions/2","title":"ConfluentSchemaRegistry.get_versions/2","type":"function"},{"doc":"Test input schema against a particular version of a subject's schema for compatibility. Note that the compatibility level applied for the check is the configured compatibility level for the subject ( get_compatibility/2 ). If this subject's compatibility level was never changed, then the global compatibility level applies ( get_compatibility/1 ). https://docs.confluent.io/current/schema-registry/develop/api.html#post--compatibility-subjects-(string-%20subject)-versions-(versionId-%20version) Returns boolean. Examples iex&gt; ConfluentSchemaRegistry . is_compatible ( client , &quot;test&quot; , schema ) { :ok , true } iex&gt; ConfluentSchemaRegistry . is_compatible ( client , &quot;test&quot; , schema , &quot;latest&quot; ) { :ok , true } iex&gt; ConfluentSchemaRegistry . is_compatible ( client , &quot;test&quot; , schema , 1 ) { :ok , true }","ref":"ConfluentSchemaRegistry.html#is_compatible/4","title":"ConfluentSchemaRegistry.is_compatible/4","type":"function"},{"doc":"Check if a schema has already been registered under the specified subject. If so, this returns the schema string along with its globally unique identifier, its version under this subject and the subject name. https://docs.confluent.io/current/schema-registry/develop/api.html#post--subjects-(string-%20subject) Returns map with the following keys: subject (string) -- Name of the subject that this schema is registered under id (int) -- Globally unique identifier of the schema version (int) -- Version of the returned schema schema (string) -- The Avro schema string schema = &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; case ConfluentSchemaRegistry . is_registered ( client , &quot;test&quot; , schema ) do { :ok , reg } -&gt; # Found schema = reg [ &quot;schema&quot; ] schema_id = reg [ &quot;id&quot; ] { :error , 404 , %{ &quot;error_code&quot; =&gt; 40401 } } -&gt; # Subject not found { :error , 404 , %{ &quot;error_code&quot; =&gt; 40403 } } -&gt; # Schema not found { :error , code , reason } -&gt; # Other error end Examples iex&gt; ConfluentSchemaRegistry . is_registered ( client , &quot;test&quot; , schema ) { :ok , %{ &quot;id&quot; =&gt; 21 , &quot;schema&quot; =&gt; &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; , &quot;subject&quot; =&gt; &quot;test&quot; , &quot;version&quot; =&gt; 1 } } iex&gt; ConfluentSchemaRegistry . is_registered ( client , &quot;test2&quot; , schema ) { :error , 404 , %{ &quot;error_code&quot; =&gt; 40401 , &quot;message&quot; =&gt; &quot;Subject not found. ...&quot; } }","ref":"ConfluentSchemaRegistry.html#is_registered/3","title":"ConfluentSchemaRegistry.is_registered/3","type":"function"},{"doc":"Register a new schema under the specified subject. If successfully registered, this returns the unique identifier of this schema in the registry. https://docs.confluent.io/current/schema-registry/develop/api.html#post--subjects-(string-%20subject)-versions Returns the integer id. case ConfluentSchemaRegistry . register_schema ( client , &quot;test&quot; , schema ) do { :ok , schema_id } -&gt; # Already registered { :error , 409 , reason } -&gt; # Conflict -- Incompatible Avro schema { :error , 422 , reason } -&gt; # Unprocessable Entity, Invalid Avro schema { :error , code , reason } -&gt; # Other error end Examples iex&gt; ConfluentSchemaRegistry . register_schema ( client , &quot;test&quot; , schema ) { :ok , 21 }","ref":"ConfluentSchemaRegistry.html#register_schema/3","title":"ConfluentSchemaRegistry.register_schema/3","type":"function"},{"doc":"Update global compatibility level. Level is a string which must be one of BACKWARD, BACKWARD_TRANSITIVE, FORWARD, FORWARD_TRANSITIVE, FULL, FULL_TRANSITIVE, NONE https://docs.confluent.io/current/schema-registry/develop/api.html#put--config Returns string. Examples iex&gt; ConfluentSchemaRegistry . update_compatibility ( client , &quot;test&quot; , &quot;FULL&quot; ) { :ok , &quot;FULL&quot; }","ref":"ConfluentSchemaRegistry.html#update_compatibility/2","title":"ConfluentSchemaRegistry.update_compatibility/2","type":"function"},{"doc":"Update compatibility level for the specified subject. Leve is a string which must be one of BACKWARD, BACKWARD_TRANSITIVE, FORWARD, FORWARD_TRANSITIVE, FULL, FULL_TRANSITIVE, NONE https://docs.confluent.io/current/schema-registry/develop/api.html#put--config Returns string. Examples iex&gt; ConfluentSchemaRegistry . update_compatibility ( client , &quot;test&quot; , &quot;FULL&quot; ) { :ok , &quot;FULL&quot; }","ref":"ConfluentSchemaRegistry.html#update_compatibility/3","title":"ConfluentSchemaRegistry.update_compatibility/3","type":"function"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:code/0","title":"ConfluentSchemaRegistry.code/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:id/0","title":"ConfluentSchemaRegistry.id/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:level/0","title":"ConfluentSchemaRegistry.level/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:reason/0","title":"ConfluentSchemaRegistry.reason/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:schema/0","title":"ConfluentSchemaRegistry.schema/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:subject/0","title":"ConfluentSchemaRegistry.subject/0","type":"type"},{"doc":"","ref":"ConfluentSchemaRegistry.html#t:version/0","title":"ConfluentSchemaRegistry.version/0","type":"type"},{"doc":"Elixir client for the Confluent® Schema Registry . It implements the full REST API using the Tesla HTTP client library. This gives it support for HTTP authentication, SSL/TLS and other configuration flexibility, e.g. selecting the underlying HTTP library (e.g. Hackney). Thanks to Schemex and Avrora for inspiration.","ref":"readme.html","title":"confluent_schema_registry","type":"extras"},{"doc":"Add confluent_schema_registry to your list of dependencies in mix.exs : def deps do [ { :confluent_schema_registry , &quot;~&gt; 0.1.1&quot; } ] end Then run mix deps.get to fetch the new dependency. Documentation is on HexDocs . To generate a local copy, run mix docs . Optional dependencies By default, Tesla uses the httpc HTTP client which comes with OTP. That library is pretty bare bones, and has issues with e.g. validating SSL certificates, so I recommend using hackney . Configure it as documented in Tesla.Adapter.Hackney . config :tesla , :adapter , Tesla.Adapter.Hackney AvroSchema provides convenience functions to work with Avro schemas, tag ids, encode/decode data, and cache results for performance and reliablilty.","ref":"readme.html#installation","title":"confluent_schema_registry - Installation","type":"extras"},{"doc":"First create a client: client = ConfluentSchemaRegistry . client ( base_url : &quot;https://schemaregistry.example.com:8081/&quot; ) In the Kafka wire format , the data is prefixed by magic byte 0 to indicate that it is using the schema registry, then four bytes for the schema id, then the data. Producer On startup, a producer looks up the version of the schema matching the subject associated with the topic it is writing on. It encodes the data to binary format using the schema, then appends the schema id to the binary and sends it to Kafka. There are a couple of different options for how to get the schema, depending on the policy and permissions for updating schemas. is_registered/3 checks if a schema has already been registered under the specified subject. If so, it returns the registration. schema = &quot;{ \\&quot; type \\&quot; : \\&quot; record \\&quot; , \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; fields \\&quot; :[{ \\&quot; name \\&quot; : \\&quot; field1 \\&quot; , \\&quot; type \\&quot; : \\&quot; string \\&quot; },{ \\&quot; name \\&quot; : \\&quot; field2 \\&quot; , \\&quot; type \\&quot; : \\&quot; int \\&quot; }]}&quot; case ConfluentSchemaRegistry . is_registered ( client , &quot;test&quot; , schema ) do { :ok , reg } -&gt; # Found schema = reg [ &quot;schema&quot; ] schema_id = reg [ &quot;id&quot; ] { :error , 404 , %{ &quot;error_code&quot; =&gt; 40401 } } -&gt; # Subject not found { :error , 404 , %{ &quot;error_code&quot; =&gt; 40403 } } -&gt; # Schema not found { :error , code , reason } -&gt; # Other error end If the schema hasn't been registered, then the producer can attempt to register it using register_schema/3 . If it is successful, it returns the schema id. It can be called multiple times, and will return the same schema id. case ConfluentSchemaRegistry . register_schema ( client , &quot;test&quot; , schema ) do { :ok , schema_id } -&gt; # Already registered { :error , 409 , reason } -&gt; # Conflict -- Incompatible Avro schema { :error , 422 , reason } -&gt; # Unprocessable Entity, Invalid Avro schema { :error , code , reason } -&gt; # Other error end Another option is to use get_schema/3 to read the latest registered schema for the subject. You might do this when schema registrations are manually managed. case ConfluentSchemaRegistry . get_schema ( client , &quot;test&quot; , &quot;latest&quot; ) do { :ok , reg } -&gt; # Already registered schema = reg [ &quot;schema&quot; ] schema_id = reg [ &quot;id&quot; ] { :error , 404 , %{ &quot;error_code&quot; =&gt; 40401 } } -&gt; # Subject not found { :error , 404 , %{ &quot;error_code&quot; =&gt; 40402 } } -&gt; # Version not found { :error , 422 , reason } -&gt; # Unprocessable Entity, Invalid Avro version { :error , code , reason } -&gt; # Other error end Consumer A consumer receives data, gets the schema id from the prefix, and looks it up in the registry using get_schema/1 , getting the schema which was used to write it. It then decodes the binary using the schema. { :ok , schema } = ConfluentSchemaRegistry . get_schema ( client , 21 )","ref":"readme.html#usage","title":"confluent_schema_registry - Usage","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Changed Updated dependencies","ref":"changelog.html#0-1-1-2022-22-22","title":"Changelog - [0.1.1] - 2022-22-22","type":"extras"},{"doc":"Added Initial release","ref":"changelog.html#0-1-0-2019-12-31","title":"Changelog - [0.1.0] - 2019-12-31","type":"extras"}]